package jp.gmail.tdr;

import java.util.ArrayList;
import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.aiwolf.client.lib.AttackContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.VoteContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Status;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class MybasePlayer implements Player {

	Agent me;
	int day;
	boolean canTalk;
	boolean canWhisper;
	GameInfo currentGameInfo;
	List<Agent> others;
	List<Agent> aliveOthers;
	List<Agent> executedAgents = new ArrayList<>();
	List<Agent> killedAgents = new ArrayList<>();
	List<Judge> divinationList = new ArrayList<>();
	List<Judge> identList = new ArrayList<>();
	List<Agent> humans = new ArrayList<>();
	List<Agent> werewolves = new ArrayList<>();
	List<Double> WFlist = new ArrayList<>();
	Deque<Content> talkQueue = new LinkedList<>();
	Deque<Content> whisperQueue = new LinkedList<>();
	Agent voteCandidate;
	Agent declaredVoteCandidate;
	Agent attackVoteCandidate;
	Agent declaredAttackVoteCandidate;
	Map<Agent, Role> comingoutMap = new HashMap<>();
	int talkListHead;
	protected double out;

	@Override
	public void dayStart() {
		// TODO 自動生成されたメソッド・スタブ
		canTalk = true;
		canWhisper = currentGameInfo.getRole() == Role.WEREWOLF ? true : false;
		talkQueue.clear();
		whisperQueue.clear();
		declaredVoteCandidate = null;
		voteCandidate = null;
		declaredAttackVoteCandidate = null;
		attackVoteCandidate = null;
		talkListHead = 0;
		addExecutedAgent(currentGameInfo.getExecutedAgent());
		RNN();
		if (!currentGameInfo.getLastDeadAgentList().isEmpty()) {
			addKilledAgent(currentGameInfo.getLastDeadAgentList().get(0));
		}

	}

	private void addExecutedAgent(Agent executedAgent) {
		if (executedAgent != null) {
			aliveOthers.remove(executedAgent);
			if (!executedAgents.contains(executedAgent)) {
				executedAgents.add(executedAgent);
			}
		}
	}

	private void addKilledAgent(Agent killedAgent) {
		if (killedAgent != null) {
			aliveOthers.remove(killedAgent);
			if (!killedAgents.contains(killedAgent)) {
				killedAgents.add(killedAgent);
			}
		}
	}

	@Override
	public Agent divine() {
		// TODO 自動生成されたメソッド・スタブ
		return null;
	}

	@Override
	public void finish() {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public String getName() {
		// TODO 自動生成されたメソッド・スタブ
		return "MykonnoPlayer";
	}

	@Override
	public Agent guard() {
		// TODO 自動生成されたメソッド・スタブ
		return null;
	}

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		// TODO 自動生成されたメソッド・スタブ
		day = -1;
		me = gameInfo.getAgent();
		others = new ArrayList<>(gameInfo.getAgentList());
		others.remove(me);
		aliveOthers = new ArrayList<>(others);
		executedAgents.clear();
		killedAgents.clear();
		divinationList.clear();
		identList.clear();
		comingoutMap.clear();
		humans.clear();
		werewolves.clear();
	}

	@Override
	public String talk() {
		// TODO 自動生成されたメソッド・スタブ
		chooseVoteCandidate();
		if (voteCandidate != null && voteCandidate != declaredVoteCandidate) {
			Content content4vote = new Content(new VoteContentBuilder(
					voteCandidate));
			talkQueue.offer(content4vote);

			declaredVoteCandidate = voteCandidate;
		}
		return talkQueue.isEmpty() ? Talk.SKIP : talkQueue.poll().getText();

	}

	@Override
	public void update(GameInfo gameInfo) {
		// TODO 自動生成されたメソッド・スタブ
		currentGameInfo = gameInfo;

		if (currentGameInfo.getDay() == day + 1) {
			day = currentGameInfo.getDay();
			return;
		}

		addExecutedAgent(currentGameInfo.getLatestExecutedAgent());

		for (int i = talkListHead; i < currentGameInfo.getTalkList().size(); i++) {
			Talk talk = currentGameInfo.getTalkList().get(i);
			Agent talker = talk.getAgent();
			if (talker == me) {
				continue;
			}
			Content content = new Content(talk.getText());

			switch (content.getTopic()) {
			case COMINGOUT:
				comingoutMap.put(talker, content.getRole());

				break;
			case DIVINED:
				divinationList.add(new Judge(day, talker, content.getTarget(),
						content.getResult()));
				break;
			case IDENTIFIED:
				identList.add(new Judge(day, talker, content.getTarget(),
						content.getResult()));
				break;
			default:
				break;
			}
		}
		talkListHead = currentGameInfo.getTalkList().size();

	}

	protected <T> T randomSelect(List<T> list) {
		if (list.isEmpty()) {
			return null;
		} else {
			return list.get((int) (Math.random() * list.size()));
		}
	}

	private void RNN() {
		WFlist.add(out);
	}

	@Override
	public Agent vote() {
		// TODO 自動生成されたメソッド・スタブ
		canTalk = false;
		WFlist.add(out);
		chooseVoteCandidate();
		return voteCandidate;

	}

	@Override
	public Agent attack() {
		// TODO 自動生成されたメソッド・スタブ
		canWhisper = false;
		chooseAttackVoteCandidate();
		canWhisper = true;
		return attackVoteCandidate;
	}

	protected void chooseVoteCandidate() {
		WFlist.get(0);
		return;
	}

	public List<AgentInfo> getVoteCandidates() {
		return null;

	}

	protected void chooseAttackVoteCandidate() {
	}

	protected boolean isAlive(Agent agent) {
		return currentGameInfo.getStatusMap().get(agent) == Status.ALIVE;
	}

	protected boolean isKilled(Agent agent) {
		return killedAgents.contains(agent);
	}

	protected boolean isCo(Agent agent) {
		return comingoutMap.containsKey(agent);
	}

	protected boolean isCo(Role role) {
		return comingoutMap.containsValue(role);
	}

	protected boolean isHumano(Agent agent) {
		return humans.contains(agent);
	}

	protected boolean isWerewolf(Agent agent) {
		return werewolves.contains(agent);
	}

	@Override
	public String whisper() {
		// TODO 自動生成されたメソッド・スタブ
		chooseAttackVoteCandidate();
		if (attackVoteCandidate != null
				&& attackVoteCandidate != declaredAttackVoteCandidate) {
			Content content4attack = new Content(new AttackContentBuilder(
					attackVoteCandidate));
			whisperQueue.offer(content4attack);

			declaredAttackVoteCandidate = attackVoteCandidate;
		}
		return whisperQueue.isEmpty() ? Talk.SKIP : whisperQueue.poll()
				.getText();
	}

}
