package jp.gmail.tdr;

import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;

import org.aiwolf.client.lib.ComingoutContentBuilder;
import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinationContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.client.lib.IdentContentBuilder;
import org.aiwolf.client.lib.RequestContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class Mymedium extends Myvillager {
	int comingoutDay;
	boolean isCameout;
	Deque<Judge> identQueue = new LinkedList<>();
	Map<Agent, Species> myIdentMap = new HashMap<>();

	@Override
	protected void chooseVoteCandidate() {
		werewolves.clear();

		for (Agent agent : aliveOthers) {
			if (comingoutMap.get(agent) == Role.MEDIUM) {
				werewolves.add(agent);
			}
		}

		for (Judge j : divinationList) {
			Agent agent = j.getAgent();
			Agent target = j.getTarget();
			if (j.getResult() == Species.WEREWOLF
					&& (target == me || isKilled(target))
					|| (myIdentMap.containsKey(target) && j.getResult() != myIdentMap
							.get(target))) {
				if (isAlive(agent) && !werewolves.contains(agent)) {
					werewolves.add(agent);
				}
			}
		}

		if (werewolves.isEmpty()) {
			if (!aliveOthers.contains(voteCandidate)) {
				voteCandidate = randomSelect(aliveOthers);
			}
		} else {
			if (!werewolves.contains(voteCandidate)) {
				voteCandidate = randomSelect(werewolves);

				if (canTalk) {
					talkQueue.offer(new Content(new EstimateContentBuilder(
							voteCandidate, Role.WEREWOLF)));
					talkQueue.offer(new Content(new RequestContentBuilder(null,
							new Content(new DivinationContentBuilder(
									voteCandidate)))));
				}
			}
		}
	}

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		comingoutDay = (int) (Math.random() * 3 + 1);
		isCameout = false;
		identQueue.clear();
		myIdentMap.clear();
	}

	@Override
	public void dayStart() {
		super.dayStart();

		Judge ident = currentGameInfo.getMediumResult();
		if (ident != null) {
			identQueue.offer(ident);
			myIdentMap.put(ident.getTarget(), ident.getResult());
		}
	}

	@Override
	public String talk() {

		if (!isCameout
				&& (day >= comingoutDay
						|| (!identQueue.isEmpty() && identQueue.peek()
								.getResult() == Species.WEREWOLF) || isCo(Role.MEDIUM))) {
			talkQueue.offer(new Content(new ComingoutContentBuilder(me,
					Role.MEDIUM)));
			isCameout = true;
		}

		if (isCameout) {
			while (!identQueue.isEmpty()) {
				Judge ident = identQueue.poll();
				talkQueue.offer(new Content(new IdentContentBuilder(ident
						.getTarget(), ident.getResult())));
			}
		}
		return super.talk();
	}
}
