package jp.gmail.tdr;

import java.io.File;
import java.io.IOException;

import org.deeplearning4j.nn.api.OptimizationAlgorithm;
import org.deeplearning4j.nn.conf.GradientNormalization;
import org.deeplearning4j.nn.conf.MultiLayerConfiguration;
import org.deeplearning4j.nn.conf.NeuralNetConfiguration;
import org.deeplearning4j.nn.conf.Updater;
import org.deeplearning4j.nn.conf.layers.GravesLSTM;
import org.deeplearning4j.nn.conf.layers.RnnOutputLayer;
import org.deeplearning4j.nn.multilayer.MultiLayerNetwork;
import org.deeplearning4j.nn.weights.WeightInit;
import org.deeplearning4j.util.ModelSerializer;
import org.nd4j.linalg.activations.Activation;
import org.nd4j.linalg.lossfunctions.LossFunctions;

public class RNN {
	int seed = 123;
	int inputNum = 21;
	int outputNum = 1;

	MultiLayerConfiguration builder = new NeuralNetConfiguration.Builder()
			.seed(123)
			.optimizationAlgo(OptimizationAlgorithm.STOCHASTIC_GRADIENT_DESCENT)
			.iterations(1)
			.weightInit(WeightInit.XAVIER)
			.updater(Updater.NESTEROVS)
			.momentum(0.8)
			.learningRate(0.001)
			.useDropConnect(true)
			.gradientNormalization(
					GradientNormalization.ClipElementWiseAbsoluteValue)
			.gradientNormalizationThreshold(0.5)
			.list()
			.layer(0,
					new GravesLSTM.Builder().activation(Activation.SIGMOID)
							.nIn(inputNum).nOut(80).dropOut(0.5).build())
			.layer(1,
					new RnnOutputLayer.Builder(LossFunctions.LossFunction.MSE)
							.activation(Activation.SOFTMAX).nIn(80)
							.nOut(outputNum).build()).pretrain(false)
			.backprop(true).build();

	MultiLayerNetwork perceptron = new MultiLayerNetwork(builder);
	File f1 = new File("data/RNN.zip");
	{
		try {
			MultiLayerNetwork model = ModelSerializer
					.restoreMultiLayerNetwork(f1);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
